# Load raw data of ArrayExpress dataset "E-MTAB-1532":

datasetid <- "E-MTAB-1532"

newfolder <- "./FishingPaper/Datasetfiles"

library("ArrayExpress")
getAE(datasetid, path = newfolder, type = "raw")

adf <- try(read.AnnotatedDataFrame(paste(newfolder, "/", datasetid, ".sdrf.txt", sep="")))
datainfo <- adf@data




# Normalize data:

library("affy")

wdsafe <- getwd()
setwd(newfolder)
aboall <- ReadAffy()
setwd(wdsafe)

affydataprocessed <- rma(aboall)




# Prepare covariate matrix and target variable:

X <- t(exprs(affydataprocessed))

reorderind <- as.numeric(factor(datainfo$'Array.Data.File', levels=rownames(X)))
X <- X[reorderind,]

y <- factor(as.numeric(datainfo$'Characteristics.disease.state.'=="colorectal cancer")+1)




# Save processed dataset:

save(X, y, file="./FishingPaper/Datasetfiles/E-MTAB-1532.Rda")


# Clear workspace:
rm(list=ls());gc()
