# Install ggplot2 version 1.0.0 (with recent versions the plot does not work):
#
# packageurl <- "http://cran.r-project.org/src/contrib/Archive/ggplot2/ggplot2_1.0.0.tar.gz"
# install.packages(packageurl, repos=NULL, type="source")



# Load and process results obtained for n = 200:


load("./FishingPaper/Results/RealdataResults.Rda")

iter <- sapply(RealdataResults, function(x) x$iter)
nvar <- sapply(RealdataResults, function(x) x$nvar)
method <- sapply(RealdataResults, function(x) x$method)
error <- sapply(RealdataResults, function(x) x$error)
time <- sapply(RealdataResults, function(x) x$time)
error <- sapply(RealdataResults, function(x) x$error)


RealdataResults <- RealdataResults[!is.na(as.numeric(error))]

iter <- sapply(RealdataResults, function(x) x$iter)
nvar <- sapply(RealdataResults, function(x) x$nvar)
method <- sapply(RealdataResults, function(x) x$method)
error <- sapply(RealdataResults, function(x) x$error)
time <- sapply(RealdataResults, function(x) x$time)
error <- sapply(RealdataResults, function(x) x$error)



results <- data.frame(iter=iter, nvar=nvar, method=method, 
                      error=error, time=time)

tabiter <- table(results$iter)
iterexclude <- as.numeric(names(tabiter[tabiter!=max(tabiter)]))

results <- results[!(results$iter %in% iterexclude),]

results <- results[results$iter %in% unique(results$iter)[1:1000],]

itersgood <- unique(results$iter)

results$iter <- as.numeric(factor(results$iter))

results$time <- NULL



results2 <- reshape(results, timevar="method", idvar=c("iter", "nvar"), direction="wide")

results2$error.min <- apply(results2, 1, function(x) min(x[3:12]))
methods <- gsub("error.", "", names(results2)[3:12])
results2$error.mintwo <- apply(results2, 1, function(x) min(x[methods %in% c("penLogReg", "SVMlinear")]))






# Load and process results obtained for n = 50:


load("./FishingPaper/Results/RealdataResultsSubset.Rda")


iter <- sapply(RealdataResults, function(x) x$iter)
nvar <- sapply(RealdataResults, function(x) x$nvar)
method <- sapply(RealdataResults, function(x) x$method)
error <- sapply(RealdataResults, function(x) x$error)
time <- sapply(RealdataResults, function(x) x$time)
error <- sapply(RealdataResults, function(x) x$error)



resultssubset <- data.frame(iter=iter, nvar=nvar, method=method, 
                            error=error, time=time)


resultssubset <- resultssubset[resultssubset$iter %in% itersgood,]
resultssubset$iter <- as.numeric(factor(resultssubset$iter))

resultssubset$time <- NULL



resultssubset2 <- reshape(resultssubset, timevar="method", idvar=c("iter", "nvar"), direction="wide")

resultssubset2$error.min <- apply(resultssubset2, 1, function(x) min(x[3:12]))
methods <- gsub("error.", "", names(resultssubset2)[3:12])
resultssubset2$error.mintwo <- apply(resultssubset2, 1, function(x) min(x[methods %in% c("penLogReg", "SVMlinear")]))






# Combine results obtained for n = 200 and n = 50:

resultsall <- rbind(results2, resultssubset2)

resultsall$n <- c(rep("n = 200", nrow(results2)), rep("n = 50", nrow(resultssubset2)))




# Calculate mean min errors out of 10 methods:

meanminerrors <- rbind(sapply(unique(resultssubset2$nvar), function(x) mean(resultssubset2$error.min[resultssubset2$nvar==x])),
                       sapply(unique(results2$nvar), function(x) mean(results2$error.min[results2$nvar==x])))
rownames(meanminerrors) <- paste("n = ", c(50, 200), sep="")
colnames(meanminerrors) <- paste("nvar = ", c(2,10,200,20000), sep="")

meanminerrors



# Calculate mean min errors out of 2 methods:

resultsall$error.mintwomedian <- apply(resultsall, 1, function(x) {
  allerrs <- x[3:12]
  median(as.numeric(apply(combn(length(allerrs),2), 2, function(y) min(c(allerrs[y[1]], allerrs[y[2]])))))
})


results50 <- resultsall[resultsall$n=="n = 50",]
results200 <- resultsall[resultsall$n=="n = 200",]

meanminerrorstwo <- rbind(sapply(unique(results50$nvar), function(x) mean(results50$error.mintwomedian[results50$nvar==x])),
                          sapply(unique(results200$nvar), function(x) mean(results200$error.mintwomedian[results200$nvar==x])))
rownames(meanminerrorstwo) <- paste("n = ", c(50, 200), sep="")
colnames(meanminerrorstwo) <- paste("nvar = ", c(2,10,200,20000), sep="")

meanminerrorstwo





# Calculate 25% and 75% quantiles from the min errors out of 10 methods:

meanmin1 <- rbind(sapply(unique(resultssubset2$nvar), function(x) quantile(resultssubset2$error.min[resultssubset2$nvar==x], 0.25)),
                  sapply(unique(results2$nvar), function(x) quantile(results2$error.min[results2$nvar==x], 0.25)))
rownames(meanmin1) <- paste("n = ", c(50, 200), sep="")
colnames(meanmin1) <- paste("nvar = ", c(2,10,200,20000), sep="")

meanmin1


meanmin2 <- rbind(sapply(unique(resultssubset2$nvar), function(x) quantile(resultssubset2$error.min[resultssubset2$nvar==x], 0.75)),
                  sapply(unique(results2$nvar), function(x) quantile(results2$error.min[results2$nvar==x], 0.75)))
rownames(meanmin2) <- paste("n = ", c(50, 200), sep="")
colnames(meanmin2) <- paste("nvar = ", c(2,10,200,20000), sep="")

meanmin2





# Data frame for plotting for results for the min errors out of 10 methods:

resultstemp <- data.frame(nvar=rep(colnames(meanminerrors), each=nrow(meanminerrors)),
                          n=rep(rownames(meanminerrors), times=ncol(meanminerrors)),
                          meanmin=as.vector(meanminerrors),
                          meanmin1=as.vector(meanmin1),
                          meanmin2=as.vector(meanmin2))

resultstemp$nvar <- factor(resultstemp$nvar, levels=colnames(meanminerrors))
resultstemp$n <- factor(resultstemp$n, levels=rownames(meanminerrors))








# Calculate 25% and 75% quantiles from the min errors out of 2 methods:

meanmintwo1 <- rbind(sapply(unique(results50$nvar), function(x) quantile(results50$error.mintwomedian[results50$nvar==x], 0.25)),
                     sapply(unique(results200$nvar), function(x) quantile(results200$error.mintwomedian[results200$nvar==x], 0.25)))
rownames(meanmin1) <- paste("n = ", c(50, 200), sep="")
colnames(meanmin1) <- paste("nvar = ", c(2,10,200,20000), sep="")

meanmintwo1


meanmintwo2 <- rbind(sapply(unique(results50$nvar), function(x) quantile(results50$error.mintwomedian[results50$nvar==x], 0.75)),
                     sapply(unique(results200$nvar), function(x) quantile(results200$error.mintwomedian[results200$nvar==x], 0.75)))
rownames(meanmin1) <- paste("n = ", c(50, 200), sep="")
colnames(meanmin1) <- paste("nvar = ", c(2,10,200,20000), sep="")

meanmintwo2






# Data frame for plotting for results for the min errors out of 2 methods:

resultstemp2 <- data.frame(nvar=rep(colnames(meanminerrorstwo), each=nrow(meanminerrorstwo)),
                           n=rep(rownames(meanminerrorstwo), times=ncol(meanminerrorstwo)),
                           meanmin=as.vector(meanminerrorstwo),
                           meanmin1=as.vector(meanmintwo1),
                           meanmin2=as.vector(meanmintwo2))

resultstemp2$nvar <- factor(resultstemp2$nvar, levels=colnames(meanminerrorstwo))
resultstemp2$n <- factor(resultstemp2$n, levels=rownames(meanminerrorstwo))





# Combine plotting data frames contructed above to one single plotting data frame:

resultstempall <- rbind(resultstemp, resultstemp2)
resultstempall$errorkind <- c(rep("minall", times=nrow(resultstemp)), rep("mintwo", times=nrow(resultstemp2)))


spacingbars <- 0.1
resultstempall$x <- as.numeric(as.factor(resultstempall$n)) + ifelse(resultstempall$errorkind=="minall", -1, 1)*spacingbars





# Calculate median min errors for all settings (these are shown in the plot):

results50 <- resultsall[resultsall$n=="n = 50",]
results200 <- resultsall[resultsall$n=="n = 200",]


medianminerrorstwo <- rbind(sapply(unique(results50$nvar), function(x) median(results50$error.mintwomedian[results50$nvar==x])),
                            sapply(unique(results200$nvar), function(x) median(results200$error.mintwomedian[results200$nvar==x])))
rownames(medianminerrorstwo) <- paste("n = ", c(50, 200), sep="")
colnames(medianminerrorstwo) <- paste("nvar = ", c(2,10,200,20000), sep="")

medianminerrorstwo


medianminerrors <- rbind(sapply(unique(results50$nvar), function(x) median(results50$error.min[results50$nvar==x])),
                         sapply(unique(results200$nvar), function(x) median(results200$error.min[results200$nvar==x])))
rownames(medianminerrors) <- paste("n = ", c(50, 200), sep="")
colnames(medianminerrors) <- paste("nvar = ", c(2,10,200,20000), sep="")

medianminerrors

resultstempall$medianmin <- c(as.vector(medianminerrors), as.vector(medianminerrorstwo))






# Visualize results from the example study (Figure 6.1):

# NOTE: ggplot2 version 1.0.0 was used. The following code does not work with recent ggplot2 versions.

library("ggplot2")

p <- ggplot(data=resultstempall, aes(x=factor(n), y=medianmin)) + 
  geom_hline(yintercept=0.5, colour="green3") + 
  geom_point(aes(x=x, colour=errorkind), size=2.5) + facet_wrap(~ nvar, nrow=1, ncol=4) +
  geom_errorbar(aes(x=x, ymin=meanmin1, ymax=meanmin2, colour=errorkind), width=0.15) +
  labs(y="Error after fishing for significance") + 
  theme(axis.title.x=element_blank())  +
  scale_x_discrete(breaks=1:2, labels=paste("n =", c(50,200)), expand=c(0.45,-1)) + 
  scale_colour_discrete(name="Number of\ntried methods", labels=c(10, 2))

p

ggsave(file="./FishingPaper/Results/MinimalErrors.pdf", width=9, height=3)
